Bug 844748 - Review Request: openbios - OpenBIOS implementation of IEEE 1275-1994
Review Request: openbios - OpenBIOS implementation of IEEE 1275-1994
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Scherer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-31 11:44 EDT by Richard W.M. Jones
Modified: 2012-08-13 20:52 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-13 20:52:26 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
misc: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Richard W.M. Jones 2012-07-31 11:44:09 EDT
Spec URL: http://oirase.annexia.org/reviews/roms/openbios.spec
SRPM URL: http://oirase.annexia.org/reviews/roms/openbios-1.0-5.svn1061.fc17.src.rpm
Description: OpenBIOS implementation of IEEE 1275-1994
Fedora Account System Username: rjones

A few things to note about this package:
 - It was previously in Fedora.  In fact, I have based this package
   off the last Fedora release:
   http://pkgs.fedoraproject.org/gitweb/?p=openbios.git;a=blob;f=openbios.spec;h=2444d466c4ac2c5564b9d1b42e77a1ebd724b3df;hb=5ec050fe2d5aafd6a47aec929b6771d8928998cb

 - The initial version was chosen to be > the previous Fedora version.

 - Instead of the previous subpackage split (which was only necessary
   because of build concerns), I've jammed everything into one
   package.  This doesn't matter much because ...

 - The cross-compiler only supports 64 bit, so we can only build
   sparc64 at present.  Need to fix cross-gcc to allow 32 bit packages
   to be built (fairly trivial).

 - For background, please read this thread *and* followups:
   https://lists.fedoraproject.org/pipermail/packaging/2012-July/008557.html

Koji scratch build:

http://koji.fedoraproject.org/koji/taskinfo?taskID=4345463

rpmlint output is bogus:

openbios.src: W: name-repeated-in-summary C OpenBIOS
openbios.src: W: spelling-error %description -l en_US noticably -> noticeably, notably
openbios.src: W: spelling-error %description -l en_US coreboot -> co reboot, co-reboot, core boot
openbios.src:17: W: macro-in-comment %{svnrel}
openbios.src:19: W: macro-in-comment %{name}
openbios.src:19: W: macro-in-comment %{version}
openbios.src:20: W: macro-in-comment %{name}
openbios.src:20: W: macro-in-comment %{version}
openbios.src:20: W: macro-in-comment %{svnrel}
openbios.src:20: W: macro-in-comment %{name}
openbios.src:20: W: macro-in-comment %{version}
openbios.src:21: W: macro-in-comment %{name}
openbios.src:21: W: macro-in-comment %{version}
openbios.src:76: W: macro-in-comment %{_datadir}
openbios.src:77: W: macro-in-comment %{_datadir}
openbios.src: W: invalid-url Source0: openbios-1.0-svn1061.tar.gz
openbios.noarch: W: name-repeated-in-summary C OpenBIOS
openbios.noarch: W: spelling-error %description -l en_US noticably -> noticeably, notably
openbios.noarch: W: spelling-error %description -l en_US coreboot -> co reboot, co-reboot, core boot
openbios.noarch: E: arch-independent-package-contains-binary-or-object /usr/share/qemu/openbios-sparc64
2 packages and 0 specfiles checked; 1 errors, 19 warnings.
Comment 1 Richard W.M. Jones 2012-07-31 13:32:26 EDT
(In reply to comment #0)
>  - The cross-compiler only supports 64 bit, so we can only build
>    sparc64 at present.  Need to fix cross-gcc to allow 32 bit packages
>    to be built (fairly trivial).

This part turns out not to be true.

Updated to add ppc 32 bit support (same URLs, different content):

Spec URL: http://oirase.annexia.org/reviews/roms/openbios.spec
SRPM URL: http://oirase.annexia.org/reviews/roms/openbios-1.0-5.svn1061.fc17.src.rpm
Comment 2 Michael Scherer 2012-07-31 15:57:55 EDT
A first comment, the patch require a mention of them being sent upstream ( if this was done ), or reason ( if it wasn't ).

https://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

Otherwise, look quite good, so I will start the formal review.
Comment 3 Michael Scherer 2012-07-31 16:07:29 EDT
The licensing is however quite messy so it may take longer than I hoped.
Comment 4 Michael Scherer 2012-07-31 16:18:00 EDT
There is also lots of code copied from various project ( gcc, freebsd, grub ), so I am not that comfortable to say "yes" without approval from FESCO, and from a legal point of view, I am not sure if that GPL v2 or GPL v2+. 



Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[-]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[?]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[-]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[!]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package contains desktop file if it is a GUI application.
[-]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[!]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)", "*No copyright* GPL", "GPL", "GPL (with incorrect FSF
     address)", "BSD (3 clause)", "GPL (v2)", "GPL (v2 or later)" For detailed
     output of licensecheck see file:
     /home/misc/checkout/git/FedoraReview/844748-openbios/licensecheck.txt
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[-]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[!]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


Issues
------
[!]: MUST Package contains no bundled libraries.
[!]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[!]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (2 clause)", "*No copyright* GPL", "GPL", "GPL (with incorrect FSF
     address)", "BSD (3 clause)", "GPL (v2)", "GPL (v2 or later)" For detailed
     output of licensecheck see file:
     /home/misc/checkout/git/FedoraReview/844748-openbios/licensecheck.txt
[?]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

Rpmlint
-------
Checking: openbios-1.0-5.svn1061.fc17.noarch.rpm
          openbios-1.0-5.svn1061.fc17.src.rpm
openbios.noarch: W: name-repeated-in-summary C OpenBIOS
openbios.noarch: W: spelling-error %description -l en_US noticably -> noticeably, notably
openbios.noarch: W: spelling-error %description -l en_US coreboot -> co reboot, co-reboot, core boot
openbios.noarch: E: arch-independent-package-contains-binary-or-object /usr/share/qemu/openbios-ppc
openbios.noarch: E: arch-independent-package-contains-binary-or-object /usr/share/qemu/openbios-sparc64
openbios.noarch: E: arch-independent-package-contains-binary-or-object /usr/share/qemu/openbios-sparc32
openbios.src: W: name-repeated-in-summary C OpenBIOS
openbios.src: W: spelling-error %description -l en_US noticably -> noticeably, notably
openbios.src: W: spelling-error %description -l en_US coreboot -> co reboot, co-reboot, core boot
openbios.src:17: W: macro-in-comment %{svnrel}
openbios.src:19: W: macro-in-comment %{name}
openbios.src:19: W: macro-in-comment %{version}
openbios.src:20: W: macro-in-comment %{name}
openbios.src:20: W: macro-in-comment %{version}
openbios.src:20: W: macro-in-comment %{svnrel}
openbios.src:20: W: macro-in-comment %{name}
openbios.src:20: W: macro-in-comment %{version}
openbios.src:21: W: macro-in-comment %{name}
openbios.src:21: W: macro-in-comment %{version}
openbios.src: W: invalid-url Source0: openbios-1.0-svn1061.tar.gz
2 packages and 0 specfiles checked; 3 errors, 17 warnings.


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:
Requires
--------
openbios-1.0-5.svn1061.fc17.noarch.rpm (rpmlib, GLIBC filtered):
    

Provides
--------
openbios-1.0-5.svn1061.fc17.noarch.rpm:
    
    openbios = 1.0-5.svn1061.fc17

MD5-sum check
-------------


Generated by fedora-review 0.2.0 (a5c4ced) last change: 2012-07-22
Command line :./try-fedora-review -b 844748
External plugins:
Comment 5 Richard W.M. Jones 2012-07-31 16:28:57 EDT
(In reply to comment #2)
> A first comment, the patch require a mention of them being sent upstream (
> if this was done ), or reason ( if it wasn't ).
> 
> https://fedoraproject.org/wiki/Packaging:
> Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

I've added these to the spec file.  Note that none of the
patches are suitable for upstreaming because they are all
specific to peculiarities of Fedora.
Comment 7 Richard W.M. Jones 2012-07-31 16:36:36 EDT
Hmm apparently NoScript rewrites that URL for some reason.
Comment 8 Richard W.M. Jones 2012-08-01 10:40:48 EDT
The latest seems to be that we can use the most strict license,
which appears to be GPLv2.  See:

https://lists.fedoraproject.org/pipermail/legal/2012-August/001942.html
Comment 9 Michael Scherer 2012-08-01 11:07:26 EDT
Now, the question is for the bundle of library. There will surely be a exception, but I prefer to have it done the right way ( even if I do not know how, open a ticket on fesco trac ? )
Comment 10 Richard W.M. Jones 2012-08-01 11:15:07 EDT
Which library do we think is bundled?  It looks like the
'libc' directory contains a few functions copied out of the
kernel (ie. nothing to do with glibc).  'libgcc' contains
some functions copied out of gcc/libgcc.  All the code is
just small string and math functions.
Comment 11 Michael Scherer 2012-08-01 12:53:25 EDT
I just asked to the FPC during today meeting ( just before going home ) and a exception was granted :

18:50:18|  spot> #action Exception granted due to the OpenBIOS usage scenario (BIOS can't link to system libs) (+1:5, 0:0, -1:0)

So I will do the final review once I am home ( in a few hours ) and then this should be good.
Comment 12 Michael Scherer 2012-08-01 16:06:55 EDT
Ok, so after looking a last time at the spec, and since the review was done and the various issues were corrected, this package is approved.
Comment 13 Richard W.M. Jones 2012-08-01 16:10:19 EDT
New Package SCM Request
=======================
Package Name: openbios
Short Description: OpenBIOS implementation of IEEE 1275-1994
Owners: rjones crobinso berrange
Branches: f16 f17
InitialCC:
Comment 14 Gwyn Ciesla 2012-08-01 16:15:20 EDT
Unorphaned devel, take ownership of devel and f16, and submit a SCM change
request for f17.
Comment 15 Richard W.M. Jones 2012-08-01 16:44:41 EDT
Package Change Request
======================
Package Name: openbios
New Branches: f17
Owners: rjones crobinso berrange
InitialCC:
Comment 16 Richard W.M. Jones 2012-08-01 17:34:41 EDT
Apparently we need to unblock something, because when I
do a build in Rawhide I see:

"BuildError: package openbios is blocked for tag f18"
Comment 17 Gwyn Ciesla 2012-08-02 08:27:40 EDT
Git done (by process-git-requests).

Yes, sorry, you need to file a ticket in rel-eng's trac to unblock openbios
since it was retired.
Comment 18 Richard W.M. Jones 2012-08-02 09:12:24 EDT
https://fedorahosted.org/rel-eng/ticket/5266
Comment 19 Gwyn Ciesla 2012-08-02 09:21:51 EDT
Already done.
Comment 20 Richard W.M. Jones 2012-08-02 09:34:04 EDT
Something in Firefox keeps changing that fedora-cvs flag ...
Comment 21 Fedora Update System 2012-08-04 02:39:17 EDT
openbios-1.0-5.svn1061.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/openbios-1.0-5.svn1061.fc17
Comment 22 Fedora Update System 2012-08-05 17:31:52 EDT
openbios-1.0-5.svn1061.fc17 has been pushed to the Fedora 17 testing repository.
Comment 23 Fedora Update System 2012-08-13 20:52:26 EDT
openbios-1.0-5.svn1061.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.